<script setup lang="ts">
    import {computed} from "vue";

    const props = defineProps(["dataset", "fields", "labels", "min", "max", "s1", "q1", "q3", "s3"])

    function getPercentile(data, percentile) {
        const index = (percentile/100) * data.length;
        let result;

        if (Math.floor(index) == index) {
            result = (parseFloat(data[index-1]) + parseFloat(data[index])) / 2;
        } else {
            result = parseFloat(data[Math.floor(index)]);
        }

        return result;
    }

    const getSeries = computed(() => {
        const data : any[] = [];

        for(let fieldIndex in props.fields) {
            const filterData = props.dataset.map(element => element[props.fields[fieldIndex]]).filter(elem => elem !== undefined).sort((a, b) => a - b);

            const s1 = getPercentile(filterData, props.s1 || 1);
            const q1 = getPercentile(filterData, props.q1 || 30);
            const median = getPercentile(filterData, 50);
            const q3 = getPercentile(filterData, props.q3 || 70); // TODO
            const s3 = getPercentile(filterData, props.s3 || 99);

            const dataPoint = {
                x: props.labels[fieldIndex],
                y: [
                    s1,
                    q1,
                    median,
                    q3,
                    s3
                ]
            }

            data.push(dataPoint);
        }

        return [{
            type: "boxPlot",
            data: data
        }];
    })

    function getBoxplotChartOptions() {
        return {
            chart: {
                type: 'boxPlot',
                height: "100%",
                width: "100%",
                toolbar: {
                    show: false
                },
                zoom: {
                    enabled: false
                }
            },
            plotOptions: {
                bar: {
                    horizontal: true
                },
                boxPlot: {
                    colors: {
                        upper: 'rgba(30, 144, 255, 1)',
                        lower: 'rgba(30, 144, 255, 0.3)'
                    }
                }
            },
            yaxis: {
                decimalsInFloat: 0,
                min: props.min,
                max: props.max,
                labels: {
                    maxWidth: 320
                }
            },
            dataLabels: {
                formatter: function (val, {seriesIndex, w}) {
                    return w.config.series[seriesIndex];
                }
            }
        };
    }

</script>
<template>
    <apexchart height="100%" :series="getSeries" :options="getBoxplotChartOptions()"></apexchart>
</template>